package require stooop
namespace import stooop::*

namespace eval ::Aldec::NCsimConverter {

	class Token {
	
		proc Token { this _string _type } {
			set ($this,m_string) $_string
			set ($this,m_type) $_type
		}
		
		proc ~Token { this } {
		
		}
		
		proc getType { this } {
			return $($this,m_type)
		}
		
		proc getString { this } {
			return $($this,m_string)
		}
		
		proc setString { this _string } {
			set ($this,m_string) $_string
			set ($this,m_type) [expr $($this,m_type) | [TYPE_STRING]]
			if { [isEmpty $this] } {
				set ($this,m_type) [expr $($this,m_type) & ~[TYPE_EMPTY]]
			}
			setConverted $this
		}
		
		proc setConverted { this } {
			set ($this,m_type) [expr $($this,m_type) | [TYPE_CONVERTED]]
		}
		
		proc isConverted { this } {
			return [expr ( $($this,m_type) & [TYPE_CONVERTED] ) != 0]
		}
		
		proc isEmpty { this } {
			return [expr ( $($this,m_type) & [TYPE_EMPTY] ) != 0]
		}
		
		proc isString { this } {
			return [expr ( $($this,m_type) & [TYPE_STRING] ) != 0]
		}
		
		proc isOpenBrace { this } {
			return [expr ( $($this,m_type) & [TYPE_OPEN_BRACE] ) != 0]
		}		
		
		proc isCloseBrace { this } {
			return [expr ( $($this,m_type) & [TYPE_CLOSE_BRACE] ) != 0]
		}				
		
		proc TYPE_STRING {} { return 1 }
		proc TYPE_OPEN_BRACE {} { return 2 }
		proc TYPE_CLOSE_BRACE {} { return 4 }
		
		#spaces and tabs
		proc TYPE_EMPTY {} { return 8 }
		
		proc TYPE_CONVERTED {} { return 16 }		
	}
}