package require stooop
namespace import stooop::*

namespace eval ::Aldec::NCsimConverter {

	class Tokens {
	
		proc Tokens { this } {
			set ($this,m_idx) -1
			set ($this,m_tokens) {}		
		}
		
		proc ~Tokens { this } {
			eval delete $($this,m_tokens)
		}		
		
		proc clear { this } {			
			set ($this,m_idx) -1
			set ($this,m_tokens) {}
		}
		
		proc add { this _token } {
			lappend ($this,m_tokens) $_token
		}
		
		#move iterator to next element
		#return 1 if successful
		proc next { this _token } {
			upvar $_token token
			set length [llength $($this,m_tokens)]
			
			if { $length == 0 } { return 0 }
			
			if { [expr $length - 1] > $($this,m_idx) } {
				incr ($this,m_idx)
				set token [lindex $($this,m_tokens) $($this,m_idx)]
				return 1
			} else {
				return 0
			}		
		}
		
		#move iterator to previous element
		#return 1 if successful
		proc prev { this _token } {
			upvar $_token token
			if { $($this,m_idx) <= 0 } { return 0 }
			
			incr ($this,m_idx) -1
			set token [lindex $($this,m_tokens) $($this,m_idx)]
			return 1
		}
		
		#return current token
		proc getCurrent { this } {
			return [lindex $($this,m_tokens) $($this,m_idx)]
		}
		
		proc getIdx { this } {
			
			return $($this,m_idx)
		}		
		
		proc restoreIdx { this _idx } {
			set ($this,m_idx) $_idx
		}
		
		proc getTokensList { this } {
			return $($this,m_tokens)
		}
		
		proc getToken { this _idx } {
			return [lindex $($this,m_tokens) $_idx]		
		}
	}
}